/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package servlet.listener;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map;
import javax.servlet.ServletContext;
import javax.servlet.ServletContextEvent;
import javax.servlet.ServletContextListener;
import javax.servlet.ServletRegistration;
import javax.servlet.annotation.WebListener;
import servlet.ServletDynamic;

/**
 *
 * @author Korisnik
 */
@WebListener
public class MyApplicationContextListenerConfig implements ServletContextListener {

    @Override
    public void contextInitialized(ServletContextEvent sce) {
        System.out.println("-------------------------------------------------------------------");
        System.out.println("MyServletContextListenerConfig: contextInitialized");
        System.out.println("context path:" + sce.getServletContext().getContextPath());
        System.out.println("server info:" + sce.getServletContext().getServerInfo());
        System.out.println("virtual server name:" + sce.getServletContext().getVirtualServerName());

        setContextInitParams(sce.getServletContext());
        setContextAttributes(sce.getServletContext());

        registerServlets(sce.getServletContext());
        
        addInitParams("Servlet1", sce.getServletContext());
    }

    @Override
    public void contextDestroyed(ServletContextEvent sce) {
        System.out.println("-------------------------------------------------------------------");
        System.out.println("MyServletContextListenerConfig: contextDestroyed");
    }

    private void setContextInitParams(ServletContext servletContext) {
        System.out.println("-------------------------------------------------------------------");
        System.out.println("MyServletContextListenerConfig: setContextInitParams");
        servletContext.setInitParameter("context-init-param-1", "context-init-param-1-value");
        servletContext.setInitParameter("context-init-param-2", "context-init-param-2-value");
    }

    private void registerServlets(ServletContext servletContext) {
        ServletRegistration.Dynamic servlet = servletContext.addServlet("ServletDynamic", ServletDynamic.class);
        Map<String, String> initParams = new HashMap<>();
        initParams.put("init-1", "init-1 value");
        initParams.put("init-2", "init-2 value");
        
        servlet.setInitParameters(initParams);
        servlet.addMapping("/servletDynamic");
    }

    private void setContextAttributes(ServletContext servletContext) {
        servletContext.setAttribute("users", new ArrayList<>());
    }

    private void addInitParams(String servletName, ServletContext servletContext) {
        ServletRegistration servletRegistration  = servletContext.getServletRegistration(servletName);
        servletRegistration.setInitParameter("init-param1", "init-param1 value dynamic");
        servletRegistration.setInitParameter("init-param3", "init-param3 value dynamic");
    }

}
